## octave-ltfat 2.6.0+dfsg

=== DESCRIPTION ===
Name: LTFAT
Version: 2.6.0
Date: 2023-9-5
Author: Peter L. Soendergaard <peter@sonderport.dk>
Maintainer: Zdenek Prusa
Title: The Large Time-Frequency Analysis Toolbox
Description: The Large Time/Frequency Analysis Toolbox (LTFAT) is a
 Matlab/Octave toolbox for working with time-frequency analysis,
 wavelets and signal processing. It is intended both as an educational
 and a computational tool. The toolbox provides a large number of
 linear transforms including Gabor and wavelet transforms along with
 routines for constructing windows (filter prototypes) and routines
 for manipulating coefficients.
License: GPLv3+
Depends: octave (>= 3.8.0)
BuildRequires: fftw3 [Debian] libfftw3-3, lapack [Debian] liblapack3,
               blas [Debian] libblas3, portaudio [Debian] portaudio19-dev
               Java Runtime [Debian] default-jre 
Url: http://ltfat.github.io/

=== src/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1)
project (libltfat C CXX)

set(CMAKE_BUILD_TYPE Release)

option(BUILD_SHARED_LIBS
    "Build .so/.dll" ON)

option(NOBLASLAPACK
    "Disable BLAS and LAPACK dependency" ON)

option(NOFFTW
    "Disable FFTW dependency" ON)

if (MSVC)
    set(USECPP 1)
else (MSVC)
    option(USECPP
        "Use C++ compiler" OFF)
endif (MSVC)

if (NOT NOFFTW)
    FIND_LIBRARY(FFTW3_LIB NAMES fftw3 libfftw3)
    FIND_LIBRARY(FFTW3F_LIB NAMES fftw3f libfftw3f)
endif (NOT NOFFTW)

if (NOT NOBLASLAPACK)
    FIND_LIBRARY(BLAS_LIB NAMES blas libblas)
    FIND_LIBRARY(LAPACK_LIB NAMES lapack liblapack)
endif (NOT NOBLASLAPACK)

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/build)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/build)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/build)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)


if (NOBLASLAPACK)
    add_definitions(-DNOBLASLAPACK)
endif (NOBLASLAPACK)

if (NOFFTW)
    add_definitions(-DKISS)
else (NOFFTW)
    add_definitions(-DFFTW)
endif (NOFFTW)

if (MSVC)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4 /wd4706")
else (MSVC)
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra")
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra")
    SET(CMAKE_SHARED_LINKER_FLAGS "-Wl,--no-undefined -Wl,-rpath,$ORIGIN")
    SET(LIBS m)
    if(CMAKE_CROSSCOMPILING)
        SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -static-libgcc")
    endif(CMAKE_CROSSCOMPILING)
endif(MSVC)

set(OLD_CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS})
set(OLD_CMAKE_C_FLAGS ${CMAKE_C_FLAGS})

if(USECPP)
    set (CMAKE_CXX_STANDARD 11)
else(USECPP)
    set (CMAKE_C_STANDARD 99)
endif(USECPP)

if (MSVC)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /D_HAS_EXCEPTIONS=0 /EHsc")
else (MSVC)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-exceptions -fno-rtti")
    SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined -Wl,-rpath,$ORIGIN")
    SET(LIBS m)
endif(MSVC)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/modules/libltfat/include)

add_subdirectory(modules/libltfat/src)

option(DO_LIBPHASERET
    "Compile libphaseret module" OFF)

if (DO_LIBPHASERET)
    add_subdirectory(modules/libphaseret/src)
endif (DO_LIBPHASERET)

add_subdirectory(examples EXCLUDE_FROM_ALL)

=== src/Makefile ===
# This is the main Makefile for libltfat
#
# Builds three static and three shared libraries (default prefix is build/):
#
# 	libltfat.a(.so)     Contains double, single and common code
# 	libltfatd.a(.so)    Contains double and common code
# 	libltfatf.a(.so)    Contains single and common code
#
# make CROSS=x86_64-w64-mingw32.static-
# or
# make CROSS=x86_64-w64-mingw32.static- NOBLASLAPACK=1
#
# Examples:
# ---------
#
# Linking against BLAS and LAPACK from Matlab (if shared libs are desired):
#  		make BLASLAPACKLIBS="-L/usr/local/MATLAB_R2013a/bin/glnxa64 -lmwblas -lmwlapack" 
#
#  		make clean && make BLASLAPACKLIBS="-L/usr/local/MATLAB_R2013a/bin/glnxa64 -lmwblas -lmwlapack" && make build/ltfat.h

include ostools.mk

ifdef CROSS
	CC=$(CROSS)gcc
	CXX=$(CROSS)g++
	AR=$(CROSS)ar
	RANLIB=$(CROSS)ranlib
	buildprefix ?= build/$(CROSS)
	objprefix ?= obj/$(CROSS)
	MINGW=1
else
	CC?=gcc
	CXX?=g++
	AR?=ar
	RANLIB?=ranlib
	buildprefix ?= build
	objprefix ?= obj
endif

# Base CFLAGS
CFLAGS+=-Wall -Wextra -std=c99
CXXFLAGS+=-Wall -Wextra -std=c++11 -fno-exceptions -fno-rtti
LFLAGS = -Wl,--no-undefined -Lbuild/$(CROSS) $(OPTLPATH) -Wl,-rpath,$$ORIGIN

MATLABROOT ?= /usr/local/MATLAB_R2017a
PREFIX ?= /usr/local
LIBDIR = $(PREFIX)/lib
INCDIR = $(PREFIX)/include

# The following adds parameters to CFLAGS
COMPTARGET ?= release
include comptarget.mk

ifdef MINGW
	EXTRALFLAGS += -Wl,--out-implib,$@.a -static-libgcc
	BLASLAPACKLIBS?=-llapack -lblas -lgfortran -lquadmath
	# NOTE that if both static and shared libraries are to be built, 
	# the obj files must be cleared in between make calls i.e.
	# make shared
	# make cleanobj
	# make static 
	ifneq ($(MAKECMDGOALS),shared)
		CFLAGS += -DLTFAT_BUILD_STATIC
		CXXFLAGS += -DLTFAT_BUILD_STATIC
	else
		CFLAGS += -DLTFAT_BUILD_SHARED
		CXXFLAGS += -DLTFAT_BUILD_SHARED
	endif
else
	CFLAGS +=-fPIC
	CXXFLAGS +=-fPIC
endif

ifdef USECPP
ifeq ($(USECPP),1)
	CC = $(CXX)
	CFLAGS = $(CXXFLAGS)
endif
endif

FFTWLIBS?=-lfftw3 -lfftw3f
BLASLAPACKLIBS?=-llapack -lblas
MODULE ?= libltfat
SRCDIR=modules/$(MODULE)/
CFLAGS+=-I$(SRCDIR)include
objprefix:=$(objprefix)/$(MODULE)
headerbase=$(MODULE:lib%=%)

# Define source files from $(SRCDIR)/
include $(SRCDIR)src/filedefs.mk

ifdef NOBLASLAPACK
	CFLAGS+=-DNOBLASLAPACK
endif

# Convert *.c names to *.o
toCompile = $(patsubst %.c,%.o,$(files))
toCompile_complextransp = $(patsubst %.c,%.o,$(files_complextransp))
toCompile_notypechange = $(patsubst  %.c,%.o,$(files_notypechange))

COMMONFILES = $(addprefix $(objprefix)/common/d,$(toCompile_notypechange))
COMMONFILESFORSFILES = $(addprefix $(objprefix)/common/s,$(toCompile_notypechange))

DFILES   = $(addprefix $(objprefix)/double/,$(toCompile) $(toCompile_complextransp)) \
		   $(addprefix $(objprefix)/complexdouble/,$(toCompile_complextransp))
SFILES   = $(addprefix $(objprefix)/single/,$(toCompile) $(toCompile_complextransp)) \
		   $(addprefix $(objprefix)/complexsingle/,$(toCompile_complextransp))

CFLAGS += $(EXTRACFLAGS) $(OPTCFLAGS)
LFLAGS += $(EXTRALFLAGS) $(OPTLFLAGS) -lm

# Define libraries
DSTATIC = $(MODULE)d.a
SSTATIC = $(MODULE)f.a
DSSTATIC = $(MODULE).a

ifndef MINGW
	DSHARED = $(patsubst %.a,%.so,$(DSTATIC))
	SSHARED = $(patsubst %.a,%.so,$(SSTATIC))
	DSSHARED = $(patsubst %.a,%.so,$(DSSTATIC))
else
	DSHARED = $(patsubst %.a,%.dll,$(DSTATIC))
	SSHARED = $(patsubst %.a,%.dll,$(SSTATIC))
	DSSHARED = $(patsubst %.a,%.dll,$(DSSTATIC))
endif

# Define targets
DTARGET=$(buildprefix)/$(DSTATIC)
STARGET=$(buildprefix)/$(SSTATIC)
DSTARGET=$(buildprefix)/$(DSSTATIC)
SO_DTARGET=$(buildprefix)/$(DSHARED)
SO_STARGET=$(buildprefix)/$(SSHARED)
SO_DSTARGET=$(buildprefix)/$(DSSHARED)

DDEP = $(buildprefix) $(objprefix)/double $(objprefix)/complexdouble $(objprefix)/common
SDEP = $(buildprefix) $(objprefix)/single $(objprefix)/complexsingle $(objprefix)/common

all: static 

$(DSTARGET): $(DDEP) $(SDEP) $(COMMONFILES) $(DFILES) $(SFILES)
	$(AR) rv $@ $(COMMONFILES) $(DFILES) $(SFILES)
	$(RANLIB) $@

$(DTARGET): $(DDEP) $(DFILES) $(COMMONFILES)
	$(AR) rv $@ $(DFILES) $(COMMONFILES)
	$(RANLIB) $@

$(STARGET): $(SDEP) $(SFILES) $(COMMONFILESFORSFILES)
	$(AR) rv $@ $(SFILES) $(COMMONFILESFORSFILES)
	$(RANLIB) $@

$(SO_DSTARGET): $(DDEP) $(SDEP) $(COMMONFILES) $(DFILES) $(SFILES)
	$(CC) -shared -fPIC -o $@ $(COMMONFILES) $(DFILES) $(SFILES) $(LFLAGS) $(DSLFLAGS) 

$(SO_DTARGET): $(DDEP) $(COMMONFILES) $(DFILES)
	$(CC) -shared -fPIC -o $@ $(COMMONFILES) $(DFILES) $(LFLAGS) $(DLFLAGS)

$(SO_STARGET): $(SDEP) $(SFILES) $(COMMONFILESFORSFILES)
	$(CC) -shared -fPIC -o $@ $(COMMONFILESFORSFILES) $(SFILES) $(LFLAGS) $(SLFLAGS)

$(objprefix)/common/d%.o: $(SRCDIR)src/%.c
	$(CC) $(CFLAGS) -DLTFAT_DOUBLE -c $< -o $@ 

$(objprefix)/double/%.o: $(SRCDIR)src/%.c
	$(CC) $(CFLAGS) -DLTFAT_DOUBLE  -c $< -o $@

$(objprefix)/complexdouble/%.o: $(SRCDIR)src/%.c
	$(CC) $(CFLAGS) -DLTFAT_DOUBLE -DLTFAT_COMPLEXTYPE -c $< -o $@

$(objprefix)/double/kiss_%.o: $(SRCDIR)thirdparty/kissfft/%.c
	$(CC) $(CFLAGS) -DLTFAT_DOUBLE -c $< -o $@ 

$(objprefix)/common/s%.o: $(SRCDIR)src/%.c
	$(CC) $(CFLAGS)  -DLTFAT_SINGLE -c $< -o $@

$(objprefix)/single/%.o: $(SRCDIR)src/%.c
	$(CC) $(CFLAGS) -DLTFAT_SINGLE  -c $< -o $@

$(objprefix)/complexsingle/%.o: $(SRCDIR)src/%.c
	$(CC) $(CFLAGS) -DLTFAT_SINGLE -DLTFAT_COMPLEXTYPE -c $< -o $@

$(objprefix)/single/kiss_%.o: $(SRCDIR)thirdparty/kissfft/%.c
	$(CC) $(CFLAGS) -DLTFAT_SINGLE  -c $< -o $@

$(buildprefix):
	@$(MKDIR) $(subst /,$(PS)/,$(buildprefix))

$(objprefix)/%:
	@$(MKDIR) $(subst /,$(PS),$@)

.PHONY: clean cleanobj help doc doxy static shared allshared munit unit $(MODULE)

doc:
	(cd modules/libltfat ; doxygen doc/doxyconfig)
	(cd modules/libphaseret ; doxygen doc/doxyconfig)

static: $(DTARGET) $(STARGET) $(DSTARGET)

phaseret:
	$(MAKE) clean
	$(MAKE) MODULE=libphaseret

allshared:
	$(MAKE) clean
	$(MAKE) MODULE=libltfat shared 
	$(MAKE) MODULE=libphaseret shared

shared: $(SO_DTARGET) $(SO_STARGET) $(SO_DSTARGET)
	$(MAKE) $(buildprefix)/$(headerbase).h USECPP=0 CC=gcc

cleanobj:
	@-$(RMDIR) obj

clean: cleanobj
	@-$(RMDIR) build

cleanall: clean
	find . -name 'CMakeCache.txt' -o -name '*.cmake' -o -name 'CMakeFiles' -exec rm -rf {} +

help:
	@echo "USAGE: make [target]"
	@echo "Options:"
	@echo "    make [target] CONFIG=debug               Compiles the library in a debug mode"
	@echo "    make [target] NOBLASLAPACK=1             Compiles the library without BLAS and LAPACK dependencies"
	@echo "    make [target] USECPP=1                   Compiles the library using a C++ compiler"

allmunit:
	$(MAKE) clean
	$(MAKE) MODULE=libltfat munit
	$(MAKE) MODULE=libphaseret munit

munit: 
	$(MAKE) $(SO_DSTARGET) BLASLAPACKLIBS="-L$(MATLABROOT)/bin/glnxa64 -lmwblas -lmwlapack"
	$(MAKE) $(buildprefix)/$(headerbase).h USECPP=0 CC=gcc

$(buildprefix)/$(headerbase).h: $(buildprefix) 
	$(CC) -E -P -DLTFAT_NOSYSTEMHEADERS $(EXTRACFLAGS) $(OPTCFLAGS) -Imodules/libltfat/include -I$(SRCDIR)include -nostdinc $(SRCDIR)include/$(headerbase).h -o $(buildprefix)/$(headerbase).h
	sed -i '1 i #ifndef _$(headerbase)_H' $(buildprefix)/$(headerbase).h
	sed -i '1 a #define _$(headerbase)_H' $(buildprefix)/$(headerbase).h
	sed -i '2 a #ifndef LTFAT_NOSYSTEMHEADERS\n $(extradepincludes) #endif' $(buildprefix)/$(headerbase).h
	sed -i '$$ a #endif' $(buildprefix)/$(headerbase).h
	$(CC) -E -P -DLTFAT_NOSYSTEMHEADERS -Iinclude -nostdinc $(buildprefix)/$(headerbase).h -o $(buildprefix)/$(headerbase)_flat.h

install:
	install -d $(LIBDIR)
	install $(STARGET) $(DTARGET) $(DSTARGET) $(SO_STARGET) $(SO_DTARGET) $(SO_DSTARGET) $(LIBDIR)
	mkdir -p $(INCDIR)
	cp -r include/* $(INCDIR)

uninstall:
	rm -f $(LIBDIR)/$(DSTATIC) $(LIBDIR)/$(SSTATIC) $(LIBDIR)/$(DSSTATIC)
	rm -f $(LIBDIR)/$(DSHARED) $(LIBDIR)/$(SSHARED) $(LIBDIR)/$(DSSHARED)
	rm -f $(INCDIR)/$(headerbase).h
	rm -rf $(INCDIR)/$(headerbase)

=== src/examples/Makefile ===
CFLAGS+=-g -Wall -Wextra -std=c++11

SRC=$(wildcard *.c)
PROGS = $(patsubst %.c,%,$(SRC))

all: $(PROGS)

%: %.c
	$(CXX) $(CFLAGS) -g -Ofast -I.. $< -o $@ ../build/libltfat.a -lblas -llapack -lfftw3 -lc -lm -lsndfile

clean:
	-rm $(PROGS)

=== inst/blockproc/java/Makefile ===
# Use Make to process this file. 

JC=javac

FLAGS=-source 1.8 -target 1.8

include ostools.mk

default:
	$(JC) $(FLAGS) net/sourceforge/ltfat/*.java net/sourceforge/ltfat/thirdparty/*.java
	C:\Program Files\Java\jdk-15.0.2\bin\jar cf blockproc.jar net/sourceforge/ltfat/*.class net/sourceforge/ltfat/thirdparty/*.class

clean: classclean
	$(RM)  *.jar

classclean:
	$(RM) net$(PS)sourceforge$(PS)ltfat$(PS)*.class
	$(RM) net$(PS)sourceforge$(PS)ltfat$(PS)thirdparty$(PS)*.class

=== src/modules/libphaseret/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)
project (libphaseret C CXX)

option(NOBLASLAPACK
    "Disable BLAS and LAPACK dependency. Must be used if LTFAT was compiled without BLAS
    and LAPACK dependency" OFF)

if (MSVC)
    set(USECPP 1)
else (MSVC)
    option(USECPP
        "Use C++ compiler instead of C compiler" OFF)
endif (MSVC)


# FIND_LIBRARY(FFTW3_LIB NAMES fftw3 libfftw3)
# FIND_LIBRARY(FFTW3F_LIB NAMES fftw3f libfftw3f)

FIND_LIBRARY(LTFAT_LIB NAMES ltfat libltfat)
FIND_LIBRARY(LTFATF_LIB NAMES ltfatf libltfatf)
FIND_LIBRARY(LTFATD_LIB NAMES ltfatd libltfatd)

FIND_PATH(LTFAT_INCLUDE NAMES ltfat.h)

# if (NOT NOBLASLAPACK)
#     FIND_LIBRARY(BLAS_LIB NAMES blas libblas)
#     FIND_LIBRARY(LAPACK_LIB NAMES lapack liblapack)
# endif (NOT NOBLASLAPACK)

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/build)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/build)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/build)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/thirdparty)
include_directories(${LTFAT_INCLUDE})

add_subdirectory(src)

=== src/modules/libltfat/testing/cUnit/Makefile ===
CFILES = $(shell ls test_*.c)

run_all: test_all_libltfat
	LD_LIBRARY_PATH=../../build ./test_all_libltfat

test_all_libltfat: Makefile ../../build/libltfat.so $(CFILES)
	$(CC) -Wall -Wextra -pedantic -std=gnu99 -O0 -g -I../../include -I../../thirdparty test_all_libltfat.c -o test_all_libltfat -L../../build -lltfat -lfftw3 -lfftw3f -lm

mem: test_all_libltfat
	LD_LIBRARY_PATH=../../build valgrind --leak-check=yes  ./test_all_libltfat 

clean:
	-rm -f *.o
	find . -type f -executable -exec sh -c "file -i '{}' | grep -q 'x-executable; charset=binary'" \; -print | xargs rm -f

test_%: test_%.c  Makefile
	$(shell truncate -s 0 runner_test_typecomplexindependent.c)
	$(shell truncate -s 0 runner_test_typeindependent.c)
	$(shell echo 'int TEST_NAME($@)(){' >> runner_test_typeindependent.c)
	$(shell	echo '#include "$<"' >> runner_test_typeindependent.c)
	$(shell echo 'return 0;}' >> runner_test_typeindependent.c)
	$(shell sed 's/%FUNCTIONNAME%/$@/g' runner_template.c > runner.c)
	$(CC) -Wall -Wextra -pedantic -std=c99 -O0 -g -I../../include -I../../thirdparty runner.c -o $@ -L../../build -lltfat -lfftw3 -lfftw3f -lm
	LD_LIBRARY_PATH=../../build ./$@
	-rm -f ./$@

.PHONY: run_all

=== debian/changelog ===
octave-ltfat (2.6.0+dfsg-7) unstable; urgency=medium

  * Team upload

  [ Rafael Laboissière ]
  * d/control: Bump Standards-Version to 4.7.2 (no changes needed)
  * d/control: Drop “Rules-Requires-Root: no”, which is now the default

  [ Sébastien Villemot ]
  * no-cxx11.patch: new patch, fixes FTBFS against Octave 10 (Closes: #1114617)

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 20 Sep 2025 21:36:27 +0200

octave-ltfat (2.6.0+dfsg-6) unstable; urgency=medium

  * Print all output from unit tests
  * Exercice all unit tests

 -- Rafael Laboissière <rafael@debian.org>  Mon, 06 Nov 2023 15:52:20 -0300

octave-ltfat (2.6.0+dfsg-5) unstable; urgency=medium

  * d/check.m: Drop unit test test_nsdgt

 -- Rafael Laboissière <rafael@debian.org>  Sun, 05 Nov 2023 15:20:13 -0300

octave-ltfat (2.6.0+dfsg-4) unstable; urgency=medium

  * d/check.m: Drop unit test test_pconv

 -- Rafael Laboissière <rafael@debian.org>  Sun, 05 Nov 2023 05:08:48 -0300

octave-ltfat (2.6.0+dfsg-3) unstable; urgency=medium

  * d/p/test_dgt_fb_alg-function-name.patch: Add Applied-Upstream header
  * d/p/remove-cd-ltfatstart.patch: New patch
  * d/p/test-pfilt-1-function-name.patch: New patch
  * d/p/test-banners.patch: New patch
  * Add mechanism for excluding unit tests
    + d/check.m: Introduce variable LTFAT_TESTS_EXCLUDE
    + d/p/exclude-tests.patch: New patch
  * d/rules: Remove useless scripts im2double.m and normalize.m

 -- Rafael Laboissière <rafael@debian.org>  Fri, 03 Nov 2023 10:45:41 -0300

octave-ltfat (2.6.0+dfsg-2) unstable; urgency=medium

  * d/p/test_dgt_fb_alg-function-name.patch: New patch
  * d/check.m: Set seed for random numbers generator.
    This is an attempt to make the package build reproducible and, hence
    to fix Bug#1054178.

 -- Rafael Laboissière <rafael@debian.org>  Fri, 20 Oct 2023 10:25:14 -0300

octave-ltfat (2.6.0+dfsg-1) unstable; urgency=medium

  * New upstream version 2.6.0+dfsg
  * d/copyright:
    + Reflect upstream changes
    + Update Source URL
  * d/p/default-java18.patch: Drop patch (applied upstream)
  * d/p/jar-path.patch: New patch
  * d/rules: Remove the extraneously installed README.md files
  * Run all tests without restriction
    + d/p/global-unit-tests-list.patch: Drop patch (no need anymore for
      the global variable LTFAT_TESTS_TODO).
    + d/check.m: Run all tests, without exclusions

 -- Rafael Laboissière <rafael@debian.org>  Sun, 17 Sep 2023 08:34:33 -0300

=== debian/control ===
Source: octave-ltfat
Section: math
Priority: optional
Maintainer: Debian Octave Group <team+pkg-octave-team@tracker.debian.org>
Uploaders: Rafael Laboissière <rafael@debian.org>
Build-Depends: default-jdk (>= 2:1.8~),
               debhelper-compat (= 13),
               dh-sequence-octave,
               octave (>> 4.0.0~rc4-1)
Standards-Version: 4.7.2
Homepage: https://ltfat.org/
Vcs-Git: https://salsa.debian.org/pkg-octave-team/octave-ltfat.git
Vcs-Browser: https://salsa.debian.org/pkg-octave-team/octave-ltfat
Testsuite: autopkgtest-pkg-octave

Package: octave-ltfat-common
Architecture: all
Depends: ${misc:Depends}, ${octave:Depends}
Description: Large Time/Frequency Analysis Toolbox (arch-indep files)
 This package provides a Matlab/Octave toolbox for working with
 time-frequency analysis, wavelets and signal processing. It is
 intended both as an educational and a computational tool. The toolbox
 provides a large number of linear transforms including Gabor and
 wavelet transforms along with routines for constructing windows
 (filter prototypes) and routines for manipulating coefficients.
 .
 This Octave add-on package is part of the Octave-Forge project.
 .
 This package contains the architecture-independent files for the
 octave-ltfat package.

Package: octave-ltfat
Architecture: any
Depends: ${misc:Depends}, ${octave:Depends}, ${shlibs:Depends},
 octave-ltfat-common (= ${source:Version})
Suggests: octave-signal
Description: Large Time/Frequency Analysis Toolbox
 This package provides a Matlab/Octave toolbox for working with
 time-frequency analysis, wavelets and signal processing. It is
 intended both as an educational and a computational tool. The toolbox
 provides a large number of linear transforms including Gabor and
 wavelet transforms along with routines for constructing windows
 (filter prototypes) and routines for manipulating coefficients.
 .
 This Octave add-on package is part of the Octave-Forge project.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

%:
	dh $@ --buildsystem=octave

export CFLAGS = $(shell dpkg-buildflags  --get CFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)

ifeq ($(dpkg-architecture -qDEB_BUILD_ARCH),mips64el)
DEB_BUILD_MAINT_OPTIONS = nocheck
endif

# The following rule is needed because an empty lib/ directory is
# needed for building the package correctly.  Even though there is one
# in the tarball, it is not created by gbp-import-orig, hence the
# mkdir command below.
execute_before_dh_auto_configure:
	mkdir -p lib

# Build the blockproc.jar file, which is deleted from the upstream
# tarball and clean up the generated *.class files
execute_after_dh_auto_build:
	$(MAKE) -C inst/blockproc/java
	find inst/blockproc/java -name \*.class | xargs rm -f

indepdir = debian/octave-ltfat-common/usr/share

execute_after_dh_install:
	rm -rf $(indepdir)/octave/packages/ltfat-*/ltfat

execute_before_dh_installdeb-indep:
	# Remove extraneous README file
	rm $(indepdir)/octave/packages/ltfat-*/README*
	# Remove useless Python script
	rm $(indepdir)/octave/packages/ltfat-*/private/test_ltfatarghelper.py
	# Remove useless scripts im2double.m and normalize.m
	# (they are identical to the ones shipped with Octave)
	for i in im2double.m normalize.m ; do			\
	    find $(indepdir) -name $$i -exec rm \{} \; ;	\
	done
